from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO
from Products.CMFCore.CMFCorePermissions import setDefaultRoles
from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.PloneTemplates.config import *

def install(self):

    out = StringIO()

    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)
    print >>out, "Switched to DynamicViewFTI: %s" % ', '.join(migrated)

    portal = getToolByName(self,'portal_url').getPortalObject()

    if not hasattr(self, 'PloneTemplates_tool'):
        addTool = portal.manage_addProduct['PloneTemplates'].manage_addTool
        addTool(type='PloneTemplates tool')    
    
    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    if 'Template' not in types:
        types.append('Template')
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)

        
    #register the folderish items in portal_properties/site_properties for folder-contents views etc
    site_props = getToolByName(self, 'portal_properties').site_properties
    use_folder_tabs = site_props.getProperty('use_folder_tabs')
    if not 'Template' in use_folder_tabs:
        site_props._updateProperty('use_folder_tabs', tuple(use_folder_tabs) + ('Template',))
    
    use_folder_contents = site_props.getProperty('use_folder_contents')
    if not 'Template' in use_folder_contents:
        site_props._updateProperty('use_folder_contents', tuple(use_folder_tabs) + ('Template',))
        
    # set the workflow
    wf_tool = getToolByName(self, 'portal_workflow')
    wf_tool.setChainForPortalTypes( ('Template',), ['folder_workflow']) 
        
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

            