from Globals import package_home
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
import os, os.path, content, sys
from Products.CMFCore.utils import ContentInit
from Products.PloneTemplates.Permissions import wireAddPermissions

from config import *

from Globals import InitializeClass

# Module aliases - we don't always get it right on the first try, but and we
# can't move modules around because things are stored in the ZODB with the
# full module path. However, we can create aliases for backwards compatability.
sys.modules['Products.PloneTemplates.Template'] = content.template

registerDirectory(SKINS_DIR, GLOBALS)


def initialize(context):
    ##Import Types here to register them
    from content import Template

    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    from Products.PloneTemplates.Permissions import permissions
    
    allTypes = zip(content_types, constructors)
    wireAddPermissions()
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECTNAME, atype.archetype_name)
        ContentInit(
            kind,
            content_types      = (atype,),
            permission         = permissions[atype.portal_type],
            extra_constructors = (constructor,),
            fti                = ftis,
            ).initialize(context)

    from TemplateTool import PloneTemplatesTool
    utils.ToolInit(
        'PloneTemplates tool', 
        tools=(TemplateTool.PloneTemplatesTool,),  
        product_name='PloneTemplates', 
        icon='tool.gif', ).initialize(context)

    # patch types
    import PatchSchemas